#include <bits/stdc++.h>
using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	unsigned int N, Q; cin >> N >> Q;
	unsigned int A[N];
	for (int i = 0; i < N; i++){
		cin >> A[i];
		A[i] = floor(log2(A[i]));
	}
	int maksimalni;
	while(Q--){
		int L, R; cin >> L >> R;
		unordered_map<int, int> mapa;
		for (int i = L-1; i < R; i++){
			mapa[A[i]]++;
			maksimalni = mapa[A[i]];
		}
		for (pair<int, int> it : mapa){
			maksimalni = max(maksimalni, it.second);
		}
		cout << maksimalni << '\n';
		
	}
	


return 0;
}